package org.ovirt.engine.core.common.vdscommands;

import org.ovirt.engine.core.compat.Guid;

public class ResetIrsVDSCommandParameters extends IrsBaseVDSCommandParameters {

    private Guid privateVdsId;

    private Guid preferredSPMId;

    public ResetIrsVDSCommandParameters() {
    }

    public ResetIrsVDSCommandParameters(Guid storagePoolId, Guid vdsId) {
        super(storagePoolId);
        setVdsId(vdsId);
    }

    public ResetIrsVDSCommandParameters(Guid storagePoolId, Guid vdsId, Guid preferredSPMId) {
        this(storagePoolId, vdsId);
        setPreferredSPMId(preferredSPMId);
    }

    public Guid getVdsId() {
        return privateVdsId;
    }

    public void setVdsId(Guid value) {
        privateVdsId = value;
    }

    private boolean privateIgnoreStopFailed;

    public boolean getIgnoreStopFailed() {
        return privateIgnoreStopFailed;
    }

    public Guid getPreferredSPMId() {
        return preferredSPMId;
    }

    public void setPreferredSPMId(Guid preferredSPMId) {
        this.preferredSPMId = preferredSPMId;
    }

    public void setIgnoreStopFailed(boolean value) {
        privateIgnoreStopFailed = value;
    }

    @Override
    public String toString() {
        return String.format("%s, vdsId = %s, ignoreStopFailed = %s",
                super.toString(),
                getVdsId(),
                getIgnoreStopFailed());
    }
}
